<!--suppress UnreachableCodeJS, CommaExpressionJS -->
<div class="table-div">
    <table class="{{ table_classes|raw }}" id="{{ table_id|raw }}" data-for="{{ js_object|raw }}" data-save-url="{{ url('public_save_table') }}"></table>

    <script type="text/x-jsrender" data-jsv-tmpl="jsvTmpl" data-form="{{ filters_form.vars.name }}">
        {{ form_start(filters_form) }}
    </script>

    {% for filter in filters_form %}
        {% if (fields[filter.vars.name] is defined) %}
            <script type="text/x-jsrender" data-jsv-tmpl="jsvTmpl" data-filter="{{ filter.vars.name }}">
                {{ form_row(filter) }}
            </script>
        {% endif %}
    {% endfor %}
</div>
<script>
    TableHelper.locale('fr');
    var tableDom = $('#{{ table_id|raw }}').on('change.tableGenerator', function(event) {
        if ($(this).hasClass('initialized')) {
            return;
        }
        $(this).addClass('initialized');
        tableDom.find('> thead > tr > th[data-fieldname]:not(.filtered)').each(function() {
            var fieldname = $(this).attr('data-fieldname');
            var tmpl = tableDom.siblings('[data-filter="' + fieldname + '"]');
            if (!tmpl.length) {
                return;
            }
            var inputGroup = $($.templates(tmpl.get(0)).render());
            inputGroup.find('[id]').each(function() {
                var initialId = $(this).attr('id');
                var newId = 'uuid-' + uuid.v4();
                inputGroup.find('[for="'+initialId+'"]').attr('for', newId);
                inputGroup.find('[data-prepend-value-to="'+initialId+'"]').attr('data-prepend-value-to', newId);
                $(this).attr('id', newId);
            });

            inputGroup.find('[name]').each(function() {
                let name = $(this).attr('name');
                let m = name.match(/^(.*)\[]$/);
                $(this).attr('name', m ? m[1] + '[0][]' : name + '[0]');
            });
            var button = $('<button type="button" class="btn btn-link btn-filter">')
                .attr('data-toggle', 'dropdown')
                .attr('aria-haspopup', 'true')
                .attr('aria-expanded', 'false')
                .append('<i class="fa fa-filter" aria-hidden="true"></i>')
                .append($('<span class="sr-only">').text("Filtrer par " + fieldname))
            ;
            var th = $(this);
            var thHtml = th.html();
            var form = $('<form class="dropdown-menu filter-popup p-3">')
                .attr('action', '{{ action_url }}')
                .attr('method', 'get')
            ;
            form.append(inputGroup);
            form.append(
                $('<button type="submit" class="btn btn-default btn-small"></button>')
                    .append('<i class="fa fa-filter" aria-hidden="true"></i>')
                    .append('<span>Filtrer</span>')
            );
            th.empty()
                .append($('<span class="field fa-space">').html(thHtml))
                .append(button)
                .append(form)
            ;
        });
    });
    var {{ js_object|raw }} = new TableGenerator(tableDom);
    {{ js_object|raw }}._cookieLess = true;
    {{ js_object|raw }}.messages = {
        "favorite": "Ajouter\/supprimer des favoris",
        "confirmSwitchView": "Voulez vous enregistrer vos modifications ?",
        "confirmChangeMaxPerPage": "Vous devez recharger la page pour prendre en compte toutes les modifications. Voulez-vous le faire maintenant ?",
        "selectCheckbox": "S\u00e9lectionner",
        "selectAllCheckboxes": "S\u00e9lectionner toutes les lignes"
    };
    {{ js_object|raw }}.data = {{ json_data|raw }};
    {{ js_object|raw }}.actions = {{ json_action|raw }};

    {{ js_object|raw }}.params({{ json_params|raw }});
    {{ js_object|raw }}.loadMemory({{ json_memory|raw }});
    {{ js_object|raw }}.generateAll();
</script>
